//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2020, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2024, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <trade/trade.mqh>

int GetTotalResultOne;
int GetTotalResultTwo;
int GetTotalResultThree;
int GetTotalResultFour;
int GetTotalResultFive;
int GetTotalResultSix;
int GetTotalResultSeven;
int GetTotalResultEight;
int GetTotalResultNine;
int GetTotalResultTen;
int GetTotalResultEleven;
int GetTotalResultTwelve;
int GetTotalResultThirteen;
int GetTotalResultFourteen;
int GetTotalResultFifteen;
int GetTotalResultSixteen;
int GetTotalResultSeventeen;
int GetTotalResultEighteen;
int GetTotalResultNineteen;
int GetTotalResultTwenty;
int GetTotalResultTwentyOne;
int GetTotalResultTwentyTwo;

int GetTotalResultOne1;
int GetTotalResultTwo1;
int GetTotalResultThree1;
int GetTotalResultFour1;
int GetTotalResultFive1;
int GetTotalResultSix1;
int GetTotalResultSeven1;
int GetTotalResultEight1;
int GetTotalResultNine1;
int GetTotalResultTen1;
int GetTotalResultEleven1;
int GetTotalResultTwelve1;
int GetTotalResultThirteen1;
int GetTotalResultFourteen1;
int GetTotalResultFifteen1;
int GetTotalResultSixteen1;
int GetTotalResultSeventeen1;
int GetTotalResultEighteen1;
int GetTotalResultNineteen1;
int GetTotalResultTwenty1;
int GetTotalResultTwentyOne1;
int GetTotalResultTwentyTwo1;

int MACD_handle;
int Stochastic_handle;
int ADX_handle;
int IchimokuCloud_handle;
int WPR;
int AO;
int Bull;
int Bear;
int IchimokuCloud_handle1;
int ADX_handle1;
int Stochastic_handle1;
int MACD_handle1;
int WPR1;
int AO1;
int Bull1;
int Bear1;
int AwesomeOS;
int AwesomeOS1;
int RSI;
int RSI1;
int CCI;
int CCI1;
int Momentum;
int Momentum1;
int EMAOneDay10;
int EMAOneDay20;
int EMAOneDay30;
int EMAOneDay50;
int EMAOneDay100;
int EMAOneDay200;
int SMAOneDay10;
int SMAOneDay20;
int SMAOneDay30;
int SMAOneDay50;
int SMAOneDay100;
int SMAOneDay200;
int EMAOneMinute10;
int EMAOneMinute20;
int EMAOneMinute30;
int EMAOneMinute50;
int EMAOneMinute100;
int EMAOneMinute200;
int SMAOneMinute10;
int SMAOneMinute20;
int SMAOneMinute30;
int SMAOneMinute50;
int SMAOneMinute100;
int SMAOneMinute200;

bool RSIisRising1;
bool RSIisFalling1;
bool CCIisRising1;
bool CCIisFalling1;
bool WilliamsRPercentageisRising1;
bool WilliamsRPercentageisFalling1;
bool BullPowerisFalling1;
bool BearPowerisRising1;
bool RSIisRising;
bool RSIisFalling;
bool CCIisRising;
bool CCIisFalling;
bool WilliamsRPercentageisRising;
bool WilliamsRPercentageisFalling;
bool BullPowerisFalling;
bool BearPowerisRising;

CTrade trade;
input double Lots = 0.00001;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   MACD_handle = iMACD(_Symbol,PERIOD_CURRENT,12,26,9,PRICE_CLOSE);
   Stochastic_handle = iStochastic(_Symbol,PERIOD_CURRENT,14,3,3,MODE_SMA,STO_CLOSECLOSE);
   ADX_handle = iADX(_Symbol,PERIOD_CURRENT,14);
   IchimokuCloud_handle = iIchimoku(_Symbol,PERIOD_CURRENT,9,26, 52);
   IchimokuCloud_handle1 = iIchimoku(_Symbol,PERIOD_M1, 9, 26, 52);
   ADX_handle1 = iADX(_Symbol,PERIOD_M1, 14);
   Stochastic_handle1 = iStochastic(_Symbol,PERIOD_M1,14,3,3,MODE_SMA,STO_CLOSECLOSE);
   MACD_handle1 = iMACD(_Symbol,PERIOD_M1,12,26,9,PRICE_CLOSE);
   WPR = iWPR(_Symbol,PERIOD_CURRENT, 14);
   WPR1 = iWPR(_Symbol,PERIOD_M1, 14);
   AO = iAO(_Symbol, PERIOD_CURRENT);
   AO1 = iAO(_Symbol,PERIOD_M1);
   Bull = iBullsPower(_Symbol,PERIOD_CURRENT,13);
   Bull1 = iBullsPower(_Symbol,PERIOD_M1,13);
   Bear = iBearsPower(_Symbol,PERIOD_M1,13);
   Bear1 = iBearsPower(_Symbol,PERIOD_M1,13);
   AwesomeOS = iAO(_Symbol,PERIOD_CURRENT);
   AwesomeOS1 = iAO(_Symbol,PERIOD_M1);
   RSI = iRSI(_Symbol,PERIOD_CURRENT,14,PRICE_CLOSE);
   RSI1 = iRSI(_Symbol,PERIOD_M1,14,PRICE_CLOSE);
   CCI = iCCI(_Symbol,PERIOD_CURRENT,20,PRICE_CLOSE);
   CCI1 = iCCI(_Symbol,PERIOD_M1,20,PRICE_CLOSE);
   Momentum = iMomentum(_Symbol,PERIOD_CURRENT,10,PRICE_CLOSE);
   Momentum1 = iMomentum(_Symbol,PERIOD_M1,10,PRICE_CLOSE);
   EMAOneDay10 = iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay20 = iMA(_Symbol,PERIOD_CURRENT,20,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay30 = iMA(_Symbol,PERIOD_CURRENT,30,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay50 = iMA(_Symbol,PERIOD_CURRENT,50,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay100 = iMA(_Symbol,PERIOD_CURRENT,100,0,MODE_EMA,PRICE_CLOSE);
   EMAOneDay200 = iMA(_Symbol,PERIOD_CURRENT,200,0,MODE_EMA,PRICE_CLOSE);
   EMAOneMinute10 = iMA(_Symbol,PERIOD_M1,10,0,MODE_EMA,PRICE_CLOSE);
   EMAOneMinute20 = iMA(_Symbol,PERIOD_M1,20,0,MODE_EMA,PRICE_CLOSE);
   EMAOneMinute30 = iMA(_Symbol,PERIOD_M1,30,0,MODE_EMA,PRICE_CLOSE);
   EMAOneMinute50 = iMA(_Symbol,PERIOD_M1,50,0,MODE_EMA,PRICE_CLOSE);
   EMAOneMinute100 = iMA(_Symbol,PERIOD_M1,100,0,MODE_EMA,PRICE_CLOSE);
   EMAOneMinute200 = iMA(_Symbol,PERIOD_M1,200,0,MODE_EMA,PRICE_CLOSE);
   SMAOneDay10 = iMA(_Symbol,PERIOD_CURRENT,10,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay20 = iMA(_Symbol,PERIOD_CURRENT,20,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay30 = iMA(_Symbol,PERIOD_CURRENT,30,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay50 = iMA(_Symbol,PERIOD_CURRENT,50,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay100 = iMA(_Symbol,PERIOD_CURRENT,100,0,MODE_SMA,PRICE_CLOSE);
   SMAOneDay200 = iMA(_Symbol,PERIOD_CURRENT,200,0,MODE_SMA,PRICE_CLOSE);
   SMAOneMinute10 = iMA(_Symbol,PERIOD_M1,10,0,MODE_SMA,PRICE_CLOSE);
   SMAOneMinute20 = iMA(_Symbol,PERIOD_M1,20,0,MODE_SMA,PRICE_CLOSE);
   SMAOneMinute30 = iMA(_Symbol,PERIOD_M1,30,0,MODE_SMA,PRICE_CLOSE);
   SMAOneMinute50 = iMA(_Symbol,PERIOD_M1,50,0,MODE_SMA,PRICE_CLOSE);
   SMAOneMinute100 = iMA(_Symbol,PERIOD_M1,100,0,MODE_SMA,PRICE_CLOSE);
   SMAOneMinute200 = iMA(_Symbol,PERIOD_M1,200,0,MODE_SMA,PRICE_CLOSE);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   double DailyOpen = iOpen(_Symbol,PERIOD_CURRENT,0);
   double DailyPreviousOpen = iOpen(_Symbol,PERIOD_CURRENT,1);
   double DailyClose = iClose(_Symbol,PERIOD_CURRENT,1);

   double SMAOneDay10Array[];
   double SMAOneDay20Array[];
   double SMAOneDay30Array[];
   double SMAOneDay50Array[];
   double SMAOneDay100Array[];
   double SMAOneDay200Array[];
   ArraySetAsSeries(SMAOneDay10Array, true);
   ArraySetAsSeries(SMAOneDay20Array, true);
   ArraySetAsSeries(SMAOneDay30Array, true);
   ArraySetAsSeries(SMAOneDay50Array, true);
   ArraySetAsSeries(SMAOneDay100Array, true);
   ArraySetAsSeries(SMAOneDay200Array, true);

   double EMAOneDay10Array[];
   double EMAOneDay20Array[];
   double EMAOneDay30Array[];
   double EMAOneDay50Array[];
   double EMAOneDay100Array[];
   double EMAOneDay200Array[];
   ArraySetAsSeries(EMAOneDay10Array, true);
   ArraySetAsSeries(EMAOneDay20Array, true);
   ArraySetAsSeries(EMAOneDay30Array, true);
   ArraySetAsSeries(EMAOneDay50Array, true);
   ArraySetAsSeries(EMAOneDay100Array, true);
   ArraySetAsSeries(EMAOneDay200Array, true);

   if(CopyBuffer(EMAOneDay10, 0, 0, 1, EMAOneDay10Array) < 2 ||
      CopyBuffer(EMAOneDay20, 0, 0, 1, EMAOneDay20Array) < 2 ||
      CopyBuffer(EMAOneDay30, 0, 0, 1, EMAOneDay30Array) < 2||
      CopyBuffer(EMAOneDay50, 0, 0, 1, EMAOneDay50Array) < 2||
      CopyBuffer(EMAOneDay100, 0, 0, 1, EMAOneDay100Array) < 2||
      CopyBuffer(EMAOneDay200, 0, 0, 1, EMAOneDay200Array) < 2 ||
      CopyBuffer(SMAOneDay10, 0, 0, 1, SMAOneDay10Array) < 2 ||
      CopyBuffer(SMAOneDay20, 0, 0, 1, SMAOneDay20Array) < 2 ||
      CopyBuffer(SMAOneDay30, 0, 0, 1, SMAOneDay30Array) < 2||
      CopyBuffer(SMAOneDay50, 0, 0, 1, SMAOneDay50Array) < 2||
      CopyBuffer(SMAOneDay100, 0, 0, 1, SMAOneDay100Array) < 2||
      CopyBuffer(SMAOneDay200, 0, 0, 1, SMAOneDay200Array) < 2)
     {
      Print("Failed to read MA indicator buffer");
      return;
     }

// This is the calculations for the moving averages for the 0 index (daily time frame)
   if(SMAOneDay10Array[1] < DailyOpen)
     {
      GetTotalResultOne = 1;
     }
   else
      if(SMAOneDay10Array[1] > DailyOpen)
        {
         GetTotalResultOne = -1;
        }
   if(SMAOneDay20Array[1] < DailyOpen)
     {
      GetTotalResultTwo = 1;
     }
   else
      if(SMAOneDay20Array[1] > DailyOpen)
        {
         GetTotalResultTwo = -1;
        }
   if(SMAOneDay30Array[1] < DailyOpen)
     {
      GetTotalResultThree = 1;
     }
   else
      if(SMAOneDay30Array[1] > DailyOpen)
        {
         GetTotalResultThree = -1;
        }
   if(SMAOneDay50Array[1] < DailyOpen)
     {
      GetTotalResultFour = 1;
     }
   else
      if(SMAOneDay50Array[1] > DailyOpen)
        {
         GetTotalResultFour = -1;
        }
   if(SMAOneDay100Array[1] < DailyOpen)
     {
      GetTotalResultFive = 1;
     }
   else
      if(SMAOneDay100Array[1] > DailyOpen)
        {
         GetTotalResultFive = -1;
        }
   if(SMAOneDay200Array[1] < DailyOpen)
     {
      GetTotalResultSix = 1;
     }
   else
      if(SMAOneDay200Array[1] > DailyOpen)
        {
         GetTotalResultSix = -1;
        }
   if(EMAOneDay10Array[1] < DailyOpen)
     {
      GetTotalResultSeven = 1;
     }
   else
      if(EMAOneDay10Array[1] > DailyOpen)
        {
         GetTotalResultSeven = -1;
        }
   if(EMAOneDay20Array[1] < DailyOpen)
     {
      GetTotalResultEight = 1;
     }
   else
      if(EMAOneDay20Array[1] > DailyOpen)
        {
         GetTotalResultEight = -1;
        }
   if(EMAOneDay30Array[1] < DailyOpen)
     {
      GetTotalResultNine = 1;
     }
   else
      if(EMAOneDay30Array[1] > DailyOpen)
        {
         GetTotalResultNine = -1;
        }
   if(EMAOneDay50Array[1] < DailyOpen)
     {
      GetTotalResultTen = 1;
     }
   else
      if(EMAOneDay50Array[1] > DailyOpen)
        {
         GetTotalResultTen = -1;
        }
   if(EMAOneDay100Array[1] < DailyOpen)
     {
      GetTotalResultEleven = 1;
     }
   else
      if(EMAOneDay100Array[1] > DailyOpen)
        {
         GetTotalResultEleven = -1;
        }
   if(EMAOneDay200Array[1] < DailyOpen)
     {
      GetTotalResultTwelve = 1;
     }
   else
      if(EMAOneDay200Array[1] > DailyOpen)
        {
         GetTotalResultTwelve = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double RSIOneDay[];
   ArraySetAsSeries(RSIOneDay, true);

   if(CopyBuffer(RSI, 0, 0, 2, RSIOneDay) < 2)
     {
      Print("Failed to read 'RSI indicator buffer");
      return;
     }
   if(RSIOneDay[0] > RSIOneDay[1])
     {
      RSIisRising = true;
     }
   if(RSIOneDay[0] < RSIOneDay[1])
     {
      RSIisFalling = true;
     }
   if((RSIOneDay[0] < 30)
      && (RSIisRising == true))
     {
      GetTotalResultThirteen = 1;
     }
   else
      if((RSIOneDay[0] > 70)
         && (RSIisFalling == true))
        {
         GetTotalResultThirteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double CCIOneDay[];
   ArraySetAsSeries(CCIOneDay, true);

   if(CopyBuffer(CCI, 0, 0, 2, CCIOneDay) < 2)
     {
      Print("Failed to read 'CCI indicator buffer");
      return;
     }

   if(CCIOneDay[0] > CCIOneDay[1])
     {
      CCIisRising = true;
     }
   if(CCIOneDay[0] < CCIOneDay[1])
     {
      CCIisFalling = true;
     }

   if((CCIOneDay[0] < -100)
      && (CCIisRising == true))
     {
      GetTotalResultFourteen = 1;
     }
   else
      if((CCIOneDay[0] > 100)
         && (CCIisFalling == true))
        {
         GetTotalResultFourteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double MomentumOneDay[];
   ArraySetAsSeries(MomentumOneDay, true);

   if(CopyBuffer(Momentum, 0, 0, 2, MomentumOneDay) < 2)
     {
      Print("Failed to read Momentum indicator buffer");
      return;
     }
   if(MomentumOneDay[0] > MomentumOneDay[1])
     {
      GetTotalResultFifteen = 1;
     }
   else
      if(MomentumOneDay[0] < MomentumOneDay[1])
        {
         GetTotalResultFifteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double WPROneDay[];
   ArraySetAsSeries(WPROneDay, true);

   if(CopyBuffer(WPR, 0, 0, 2, WPROneDay) < 2)
     {
      Print("Failed to read WPR indicator buffer");
      return;
     }

   if(WPROneDay[0] > WPROneDay[1])
     {
      WilliamsRPercentageisRising = true;
     }
   if(WPROneDay[0] < WPROneDay[1])
     {
      WilliamsRPercentageisFalling = true;
     }

   if((WPROneDay[0] < -80)
      && (WilliamsRPercentageisRising == true))
     {
      GetTotalResultSixteen = 1;
     }
   else
      if((WPROneDay[0] > -20)
         && (WilliamsRPercentageisFalling == true))
        {
         GetTotalResultSixteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double BearOneDay[];
   ArraySetAsSeries(BearOneDay, true);

   if(CopyBuffer(Bear, 0, 0, 2, BearOneDay) < 2)
     {
      Print("Failed to read Bear indicator buffer");
      return;
     }

   if(BearOneDay[0] > BearOneDay[1])
     {
      BearPowerisRising = true;
     }

   double BullOneDay[];
   ArraySetAsSeries(BullOneDay, true);

   if(CopyBuffer(Bull, 0, 0, 2, BullOneDay) < 2)
     {
      Print("Failed to read Bull indicator buffer");
      return;
     }

   if(BullOneDay[0] < BullOneDay[1])
     {
      BullPowerisFalling = true;
     }
   if((BearOneDay[0] < 0)
      && (BearPowerisRising == true) && (DailyOpen > DailyPreviousOpen))
     {
      GetTotalResultSeventeen = 1;
     }
   else
      if((BullOneDay[0] > 0)
         && (BullPowerisFalling == true) && (DailyOpen < DailyPreviousOpen))
        {
         GetTotalResultSeventeen = -1;
        }

   double MACD_Main[];
   double MACD_Signal[];
   ArraySetAsSeries(MACD_Main, true);
   ArraySetAsSeries(MACD_Signal, true);

   if(CopyBuffer(MACD_handle, 0, 0, 1, MACD_Main) < 2 ||
      CopyBuffer(MACD_handle, 1, 0, 1, MACD_Signal) < 2)
     {
      Print("Failed to read MACD indicator buffer");
      return;
     }
   if(MACD_Main[0] > MACD_Signal[0])
     {
      GetTotalResultEighteen = 1;
     }
   else
      if(MACD_Main[0] < MACD_Signal[0])
        {
         GetTotalResultEighteen = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double Stochastic_Main[];
   double Stochastic_Signal[];
   ArraySetAsSeries(Stochastic_Main, true);
   ArraySetAsSeries(Stochastic_Signal, true);

   if(CopyBuffer(Stochastic_handle, 0, 0, 2, Stochastic_Main) < 2 ||
      CopyBuffer(Stochastic_handle, 1, 0, 2, Stochastic_Signal) < 2)
     {
      Print("Failed to read Stochastic indicator buffer");
      return;
     }

   if(Stochastic_Main[1] < Stochastic_Signal[1] &&
      Stochastic_Main[0] > Stochastic_Signal[0] &&
      Stochastic_Main[0] < 20)
     {
      GetTotalResultNineteen = 1; // Buy: Main line crossed above signal line and is below 20
     }
   else
      if(Stochastic_Main[1] > Stochastic_Signal[1] &&
         Stochastic_Main[0] < Stochastic_Signal[0] &&
         Stochastic_Main[0] > 80)
        {
         GetTotalResultNineteen = -1; // Sell: Main line crossed below signal line and is above 80
        }

   double ADX_PlusDI[];
   double ADX_MinusDI[];
   ArraySetAsSeries(ADX_PlusDI, true);
   ArraySetAsSeries(ADX_MinusDI, true);

   if(CopyBuffer(ADX_handle, PLUSDI_LINE, 0, 2, ADX_PlusDI) < 2 ||
      CopyBuffer(ADX_handle, MINUSDI_LINE, 0, 2, ADX_MinusDI) < 2)
     {
      Print("Failed to read ADX indicator buffer");
      return;
     }

   if((ADX_MinusDI[0] > 20) && (ADX_PlusDI[1] < ADX_MinusDI[1]) && (ADX_PlusDI[0] > ADX_MinusDI[0]))
     {
      GetTotalResultTwenty = 1; // Buy: +DI crossed above -DI and ADX > 20
     }
   else
      if((ADX_MinusDI[0] > 20) && (ADX_PlusDI[1] > ADX_MinusDI[1]) && (ADX_PlusDI[0] < ADX_MinusDI[0]))
        {
         GetTotalResultTwenty = -1; // Sell: +DI crossed below -DI and ADX > 20
        }

   double Ichimoku_BaseLine[];
   double Ichimoku_ConversionLine[];
   double Ichimoku_SenkouSpanA[];
   double Ichimoku_SenkouSpanB[];

   ArraySetAsSeries(Ichimoku_BaseLine, true);
   ArraySetAsSeries(Ichimoku_ConversionLine, true);
   ArraySetAsSeries(Ichimoku_SenkouSpanA, true);
   ArraySetAsSeries(Ichimoku_SenkouSpanB, true);

   if(CopyBuffer(IchimokuCloud_handle, KIJUNSEN_LINE, 0, 1, Ichimoku_BaseLine) < 2 ||
      CopyBuffer(IchimokuCloud_handle, TENKANSEN_LINE, 0, 1, Ichimoku_ConversionLine) < 2 ||
      CopyBuffer(IchimokuCloud_handle, SENKOUSPANA_LINE, 0, 1, Ichimoku_SenkouSpanA) < 2 ||
      CopyBuffer(IchimokuCloud_handle, SENKOUSPANB_LINE, 0, 1, Ichimoku_SenkouSpanB) < 2)
     {
      Print("Failed to read Ichimoku indicator buffer");
      return;
     }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(DailyClose > Ichimoku_BaseLine[0] &&  //Price above Base Line
      DailyClose > Ichimoku_ConversionLine[0] && //Price Above Conversion Line
      Ichimoku_ConversionLine[0] > Ichimoku_BaseLine[0] && //Conversion Line Above Base Line
      DailyClose > Ichimoku_SenkouSpanA[0] && //Price Above Senkou Span A
      DailyClose > Ichimoku_SenkouSpanB[0] && //Price Above Senkou Span B
      Ichimoku_SenkouSpanA[0] > Ichimoku_SenkouSpanB[0])
     {
      GetTotalResultTwentyOne = 1; //Buy
     }
   else
      if(DailyClose < Ichimoku_BaseLine[0] &&  //Price below Base Line
         DailyClose < Ichimoku_ConversionLine[0] && //Price Below Conversion Line
         Ichimoku_ConversionLine[0] < Ichimoku_BaseLine[0] && //Conversion Line Below Base Line
         DailyClose < Ichimoku_SenkouSpanA[0] && //Price Below Senkou Span A
         DailyClose < Ichimoku_SenkouSpanB[0] && //Price Below Senkou Span B
         Ichimoku_SenkouSpanA[0] < Ichimoku_SenkouSpanB[0])
        {
         GetTotalResultTwentyOne = -1; //Sell
        }

   double AOOneDay[];
   ArraySetAsSeries(AOOneDay, true);

   if(CopyBuffer(AwesomeOS, 0, 0, 4, AOOneDay) < 2)
     {
      Print("Failed to read AO indicator buffer");
      return;
     }
   if((AOOneDay[0] > 0) && (AOOneDay[1] < 0) && (AOOneDay[2] < AOOneDay[3]))
     {
      GetTotalResultTwentyTwo = 1;
     }
   else
      if((AOOneDay[0] < 0) && (AOOneDay[1] > 0) && (AOOneDay[2] > AOOneDay[3]))
        {
         GetTotalResultTwentyTwo = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double OneMinuteOpen = iOpen(_Symbol,PERIOD_M1,0);
   double OneMinutePreviousOpen = iOpen(_Symbol,PERIOD_M1,1);
   double OneMinuteClose = iClose(_Symbol,PERIOD_M1,1);

   double SMAOneMinute10Array[];
   double SMAOneMinute20Array[];
   double SMAOneMinute30Array[];
   double SMAOneMinute50Array[];
   double SMAOneMinute100Array[];
   double SMAOneMinute200Array[];
   ArraySetAsSeries(SMAOneMinute10Array, true);
   ArraySetAsSeries(SMAOneMinute20Array, true);
   ArraySetAsSeries(SMAOneMinute30Array, true);
   ArraySetAsSeries(SMAOneMinute50Array, true);
   ArraySetAsSeries(SMAOneMinute100Array, true);
   ArraySetAsSeries(SMAOneMinute200Array, true);

   double EMAOneMinute10Array[];
   double EMAOneMinute20Array[];
   double EMAOneMinute30Array[];
   double EMAOneMinute50Array[];
   double EMAOneMinute100Array[];
   double EMAOneMinute200Array[];
   ArraySetAsSeries(EMAOneMinute10Array, true);
   ArraySetAsSeries(EMAOneMinute20Array, true);
   ArraySetAsSeries(EMAOneMinute30Array, true);
   ArraySetAsSeries(EMAOneMinute50Array, true);
   ArraySetAsSeries(EMAOneMinute100Array, true);
   ArraySetAsSeries(EMAOneMinute200Array, true);

   if(CopyBuffer(EMAOneMinute10, 0, 0, 1, EMAOneMinute10Array) < 2 ||
      CopyBuffer(EMAOneMinute20, 0, 0, 1, EMAOneMinute20Array) < 2 ||
      CopyBuffer(EMAOneMinute30, 0, 0, 1, EMAOneMinute30Array) < 2||
      CopyBuffer(EMAOneMinute50, 0, 0, 1, EMAOneMinute50Array) < 2||
      CopyBuffer(EMAOneMinute100, 0, 0, 1, EMAOneMinute100Array) < 2||
      CopyBuffer(EMAOneMinute200, 0, 0, 1, EMAOneMinute200Array) < 2 ||
      CopyBuffer(SMAOneMinute10, 0, 0, 1, SMAOneMinute10Array) < 2 ||
      CopyBuffer(SMAOneMinute20, 0, 0, 1, SMAOneMinute20Array) < 2 ||
      CopyBuffer(SMAOneMinute30, 0, 0, 1, SMAOneMinute30Array) < 2||
      CopyBuffer(SMAOneMinute50, 0, 0, 1, SMAOneMinute50Array) < 2||
      CopyBuffer(SMAOneMinute100, 0, 0, 1, SMAOneMinute100Array) < 2||
      CopyBuffer(SMAOneMinute200, 0, 0, 1, SMAOneMinute200Array) < 2)
     {
      Print("Failed to read MA indicator buffer");
      return;
     }

// This is the calculations for the moving averages for the 1 index (OneMinute time frame)
   if(SMAOneMinute10Array[1] < OneMinuteOpen)
     {
      GetTotalResultOne1 = 1;
     }
   else
      if(SMAOneMinute10Array[1] > OneMinuteOpen)
        {
         GetTotalResultOne1 = -1;
        }
   if(SMAOneMinute20Array[1] < OneMinuteOpen)
     {
      GetTotalResultTwo1 = 1;
     }
   else
      if(SMAOneMinute20Array[1] > OneMinuteOpen)
        {
         GetTotalResultTwo1 = -1;
        }
   if(SMAOneMinute30Array[1] < OneMinuteOpen)
     {
      GetTotalResultThree1 = 1;
     }
   else
      if(SMAOneMinute30Array[1] > OneMinuteOpen)
        {
         GetTotalResultThree1 = -1;
        }
   if(SMAOneMinute50Array[1] < OneMinuteOpen)
     {
      GetTotalResultFour1 = 1;
     }
   else
      if(SMAOneMinute50Array[1] > OneMinuteOpen)
        {
         GetTotalResultFour1 = -1;
        }
   if(SMAOneMinute100Array[1] < OneMinuteOpen)
     {
      GetTotalResultFive1 = 1;
     }
   else
      if(SMAOneMinute100Array[1] > OneMinuteOpen)
        {
         GetTotalResultFive1 = -1;
        }
   if(SMAOneMinute200Array[1] < OneMinuteOpen)
     {
      GetTotalResultSix1 = 1;
     }
   else
      if(SMAOneMinute200Array[1] > OneMinuteOpen)
        {
         GetTotalResultSix1 = -1;
        }
   if(EMAOneMinute10Array[1] < OneMinuteOpen)
     {
      GetTotalResultSeven1 = 1;
     }
   else
      if(EMAOneMinute10Array[1] > OneMinuteOpen)
        {
         GetTotalResultSeven1 = -1;
        }
   if(EMAOneMinute20Array[1] < OneMinuteOpen)
     {
      GetTotalResultEight1 = 1;
     }
   else
      if(EMAOneMinute20Array[1] > OneMinuteOpen)
        {
         GetTotalResultEight1 = -1;
        }
   if(EMAOneMinute30Array[1] < OneMinuteOpen)
     {
      GetTotalResultNine1 = 1;
     }
   else
      if(EMAOneMinute30Array[1] > OneMinuteOpen)
        {
         GetTotalResultNine1 = -1;
        }
   if(EMAOneMinute50Array[1] < OneMinuteOpen)
     {
      GetTotalResultTen1 = 1;
     }
   else
      if(EMAOneMinute50Array[1] > OneMinuteOpen)
        {
         GetTotalResultTen1 = -1;
        }
   if(EMAOneMinute100Array[1] < OneMinuteOpen)
     {
      GetTotalResultEleven1 = 1;
     }
   else
      if(EMAOneMinute100Array[1] > OneMinuteOpen)
        {
         GetTotalResultEleven1 = -1;
        }
   if(EMAOneMinute200Array[1] < OneMinuteOpen)
     {
      GetTotalResultTwelve1 = 1;
     }
   else
      if(EMAOneMinute200Array[1] > OneMinuteOpen)
        {
         GetTotalResultTwelve1 = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double RSIOneMinute[];
   ArraySetAsSeries(RSIOneMinute, true);

   if(CopyBuffer(RSI1, 0, 0, 2, RSIOneMinute) < 2)
     {
      Print("Failed to read 'RSI indicator buffer");
      return;
     }
   if(RSIOneMinute[0] > RSIOneMinute[1])
     {
      RSIisRising1 = true;
     }
   if(RSIOneMinute[0] < RSIOneMinute[1])
     {
      RSIisFalling1 = true;
     }
   if((RSIOneMinute[0] < 30)
      && (RSIisRising1 == true))
     {
      GetTotalResultThirteen1 = 1;
     }
   else
      if((RSIOneMinute[0] > 70)
         && (RSIisFalling1 == true))
        {
         GetTotalResultThirteen1 = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double CCIOneMinute[];
   ArraySetAsSeries(CCIOneMinute, true);

   if(CopyBuffer(CCI1, 0, 0, 2, CCIOneMinute) < 2)
     {
      Print("Failed to read 'CCI indicator buffer");
      return;
     }

   if(CCIOneMinute[0] > CCIOneMinute[1])
     {
      CCIisRising1 = true;
     }
   if(CCIOneMinute[0] < CCIOneMinute[1])
     {
      CCIisFalling1 = true;
     }

   if((CCIOneMinute[0] < -100)
      && (CCIisRising1 == true))
     {
      GetTotalResultFourteen1 = 1;
     }
   else
      if((CCIOneMinute[0] > 100)
         && (CCIisFalling1 == true))
        {
         GetTotalResultFourteen1 = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double MomentumOneMinute[];
   ArraySetAsSeries(MomentumOneMinute, true);

   if(CopyBuffer(Momentum1, 0, 0, 2, MomentumOneMinute) < 2)
     {
      Print("Failed to read Momentum indicator buffer");
      return;
     }
   if(MomentumOneMinute[0] > MomentumOneMinute[1])
     {
      GetTotalResultFifteen1 = 1;
     }
   else
      if(MomentumOneMinute[0] < MomentumOneMinute[1])
        {
         GetTotalResultFifteen1 = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double WPROneMinute[];
   ArraySetAsSeries(WPROneMinute, true);

   if(CopyBuffer(WPR1, 0, 0, 2, WPROneMinute) < 2)
     {
      Print("Failed to read WPR indicator buffer");
      return;
     }

   if(WPROneMinute[0] > WPROneMinute[1])
     {
      WilliamsRPercentageisRising1 = true;
     }
   if(WPROneMinute[0] < WPROneMinute[1])
     {
      WilliamsRPercentageisFalling1 = true;
     }

   if((WPROneMinute[0] < -80)
      && (WilliamsRPercentageisRising1 == true))
     {
      GetTotalResultSixteen1 = 1;
     }
   else
      if((WPROneMinute[0] > -20)
         && (WilliamsRPercentageisFalling1 == true))
        {
         GetTotalResultSixteen1 = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double BearOneMinute[];
   ArraySetAsSeries(BearOneMinute, true);

   if(CopyBuffer(Bear1, 0, 0, 2, BearOneMinute) < 2)
     {
      Print("Failed to read Bear indicator buffer");
      return;
     }

   if(BearOneMinute[0] > BearOneMinute[1])
     {
      BearPowerisRising1 = true;
     }

   double BullOneMinute[];
   ArraySetAsSeries(BullOneMinute, true);

   if(CopyBuffer(Bull1, 0, 0, 2, BullOneMinute) < 2)
     {
      Print("Failed to read Bull indicator buffer");
      return;
     }

   if(BullOneMinute[0] < BullOneMinute[1])
     {
      BullPowerisFalling1 = true;
     }
   if((BearOneMinute[0] < 0)
      && (BearPowerisRising1 == true) && (OneMinuteOpen > OneMinutePreviousOpen))
     {
      GetTotalResultSeventeen1 = 1;
     }
   else
      if((BullOneMinute[0] > 0)
         && (BullPowerisFalling1 == true) && (OneMinuteOpen < OneMinutePreviousOpen))
        {
         GetTotalResultSeventeen1 = -1;
        }

   double MACD_Main1[];
   double MACD_Signal1[];
   ArraySetAsSeries(MACD_Main1, true);
   ArraySetAsSeries(MACD_Signal1, true);

   if(CopyBuffer(MACD_handle1, 0, 0, 1, MACD_Main1) < 2 ||
      CopyBuffer(MACD_handle1, 1, 0, 1, MACD_Signal1) < 2)
     {
      Print("Failed to read MACD indicator buffer");
      return;
     }
   if(MACD_Main1[0] > MACD_Signal1[0])
     {
      GetTotalResultEighteen1 = 1;
     }
   else
      if(MACD_Main1[0] < MACD_Signal1[0])
        {
         GetTotalResultEighteen1 = -1;
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double Stochastic_Main1[];
   double Stochastic_Signal1[];
   ArraySetAsSeries(Stochastic_Main1, true);
   ArraySetAsSeries(Stochastic_Signal1, true);

   if(CopyBuffer(Stochastic_handle1, 0, 0, 2, Stochastic_Main1) < 2 ||
      CopyBuffer(Stochastic_handle1, 1, 0, 2, Stochastic_Signal1) < 2)
     {
      Print("Failed to read Stochastic indicator buffer");
      return;
     }

   if(Stochastic_Main1[1] < Stochastic_Signal1[1] &&
      Stochastic_Main1[0] > Stochastic_Signal1[0] &&
      Stochastic_Main1[0] < 20)
     {
      GetTotalResultNineteen1 = 1; // Buy: Main line crossed above signal line and is below 20
     }
   else
      if(Stochastic_Main1[1] > Stochastic_Signal1[1] &&
         Stochastic_Main1[0] < Stochastic_Signal1[0] &&
         Stochastic_Main1[0] > 80)
        {
         GetTotalResultNineteen1 = -1; // Sell: Main line crossed below signal line and is above 80
        }

   double ADX_PlusDI1[];
   double ADX_MinusDI1[];
   ArraySetAsSeries(ADX_PlusDI1, true);
   ArraySetAsSeries(ADX_MinusDI1, true);

   if(CopyBuffer(ADX_handle1, PLUSDI_LINE, 0, 2, ADX_PlusDI1) < 2 ||
      CopyBuffer(ADX_handle1, MINUSDI_LINE, 0, 2, ADX_MinusDI1) < 2)
     {
      Print("Failed to read ADX indicator buffer");
      return;
     }

   if((ADX_MinusDI1[0] > 20) && (ADX_PlusDI1[1] < ADX_MinusDI1[1]) && (ADX_PlusDI1[0] > ADX_MinusDI1[0]))
     {
      GetTotalResultTwenty1 = 1; // Buy: +DI crossed above -DI and ADX > 20
     }
   else
      if((ADX_MinusDI1[0] > 20) && (ADX_PlusDI1[1] > ADX_MinusDI1[1]) && (ADX_PlusDI1[0] < ADX_MinusDI1[0]))
        {
         GetTotalResultTwenty1 = -1; // Sell: +DI crossed below -DI and ADX > 20
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double Ichimoku_BaseLine1[];
   double Ichimoku_ConversionLine1[];
   double Ichimoku_SenkouSpanA1[];
   double Ichimoku_SenkouSpanB1[];

   ArraySetAsSeries(Ichimoku_BaseLine1, true);
   ArraySetAsSeries(Ichimoku_ConversionLine1, true);
   ArraySetAsSeries(Ichimoku_SenkouSpanA1, true);
   ArraySetAsSeries(Ichimoku_SenkouSpanB1, true);

   if(CopyBuffer(IchimokuCloud_handle1, KIJUNSEN_LINE, 0, 1, Ichimoku_BaseLine1) < 2 ||
      CopyBuffer(IchimokuCloud_handle1, TENKANSEN_LINE, 0, 1, Ichimoku_ConversionLine1) < 2 ||
      CopyBuffer(IchimokuCloud_handle1, SENKOUSPANA_LINE, 0, 1, Ichimoku_SenkouSpanA1) < 2 ||
      CopyBuffer(IchimokuCloud_handle1, SENKOUSPANB_LINE, 0, 1, Ichimoku_SenkouSpanB1) < 2)
     {
      Print("Failed to read Ichimoku indicator buffer");
      return;
     }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   if(OneMinuteClose > Ichimoku_BaseLine1[0] &&  //Price above Base Line
      OneMinuteClose > Ichimoku_ConversionLine1[0] && //Price Above Conversion Line
      Ichimoku_ConversionLine1[0] > Ichimoku_BaseLine1[0] && //Conversion Line Above Base Line
      OneMinuteClose > Ichimoku_SenkouSpanA1[0] && //Price Above Senkou Span A
      OneMinuteClose > Ichimoku_SenkouSpanB1[0] && //Price Above Senkou Span B
      Ichimoku_SenkouSpanA1[0] > Ichimoku_SenkouSpanB1[0])
     {
      GetTotalResultTwentyOne1 = 1; //Buy
     }
   else
      if(OneMinuteClose < Ichimoku_BaseLine1[0] &&  //Price below Base Line
         OneMinuteClose < Ichimoku_ConversionLine1[0] && //Price Below Conversion Line
         Ichimoku_ConversionLine1[0] < Ichimoku_BaseLine1[0] && //Conversion Line Below Base Line
         OneMinuteClose < Ichimoku_SenkouSpanA1[0] && //Price Below Senkou Span A
         OneMinuteClose < Ichimoku_SenkouSpanB1[0] && //Price Below Senkou Span B
         Ichimoku_SenkouSpanA1[0] < Ichimoku_SenkouSpanB1[0])
        {
         GetTotalResultTwentyOne1 = -1; //Sell
        }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double AOOneMinute[];
   ArraySetAsSeries(AOOneMinute, true);

   if(CopyBuffer(AwesomeOS1, MAIN_LINE, 0, 4, AOOneMinute) < 2)
     {
      Print("Failed to read AO indicator buffer");
      return;
     }
   if((AOOneMinute[0] > 0) && (AOOneMinute[1] < 0) && (AOOneMinute[2] < AOOneMinute[3]))
     {
      GetTotalResultTwentyTwo1 = 1;
     }
   else
      if((AOOneMinute[0] < 0) && (AOOneMinute[1] > 0) && (AOOneMinute[2] > AOOneMinute[3]))
        {
         GetTotalResultTwentyTwo1 = -1;
        }

   double MovingAverageOneDayPreCalculation = GetTotalResultOne + GetTotalResultTwo + GetTotalResultThree + GetTotalResultFour + GetTotalResultFive + GetTotalResultSix + GetTotalResultSeven + GetTotalResultEight + GetTotalResultNine + GetTotalResultTen + GetTotalResultEleven + GetTotalResultTwelve;
   double MovingAverageOneDay = MovingAverageOneDayPreCalculation/12;

   double OSOneDayPreCalculation = GetTotalResultThirteen + GetTotalResultFourteen + GetTotalResultFifteen + GetTotalResultSixteen + GetTotalResultSeventeen + GetTotalResultEighteen + GetTotalResultNineteen + GetTotalResultTwenty + GetTotalResultTwentyOne;
   double OSOneDay = OSOneDayPreCalculation/9;

   double MovingAverageOneMinutePreCalculation = GetTotalResultOne1 + GetTotalResultTwo1 + GetTotalResultThree1 + GetTotalResultFour1 + GetTotalResultFive1 + GetTotalResultSix1 + GetTotalResultSeven1 + GetTotalResultEight1 + GetTotalResultNine1 + GetTotalResultTen1 + GetTotalResultEleven1 + GetTotalResultTwelve1;
   double MovingAverageOneMinute = MovingAverageOneMinutePreCalculation/12;

   double OSOneMinutePreCalculation = GetTotalResultThirteen1 + GetTotalResultFourteen1 + GetTotalResultFifteen1 + GetTotalResultSixteen1 + GetTotalResultSeventeen1 + GetTotalResultEighteen1 + GetTotalResultNineteen1 + GetTotalResultTwenty1 + GetTotalResultTwentyOne1;
   double OSOneMinute = OSOneMinutePreCalculation/9;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   bool UpMarket = (MovingAverageOneDay == 1 && MovingAverageOneMinute == -1 && OSOneDay > 0 && OSOneMinute == 0);
   bool DownMarket = (MovingAverageOneDay == -1 && MovingAverageOneMinute == 1 && OSOneDay < 0 && OSOneMinute == 0);

   double UnrealziedPnL = ACCOUNT_PROFIT;
   double AccountEquity = ACCOUNT_EQUITY;
   double StopLossCalculation = (UnrealziedPnL / AccountEquity)*100;
   double StopLoss = StopLossCalculation <= -5;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   double BuyPrice = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
   double SellPrice = SymbolInfoDouble(_Symbol,SYMBOL_BID);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// Check overall conditions for placing a trade
   if(BuyPrice < DailyOpen && UpMarket == true)
     {
      double EnterLong = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
      EnterLong = NormalizeDouble(EnterLong,_Digits);
      trade.Buy(Lots,NULL,EnterLong,StopLoss,NULL,"Enter Long");
     }

// Check conditions to enter a short position
   if(SellPrice > DailyOpen && DownMarket == true)
     {
      double EnterShort = SymbolInfoDouble(_Symbol,SYMBOL_BID);
      EnterShort = NormalizeDouble(EnterShort,_Digits);
      trade.Sell(Lots,NULL,EnterShort,StopLoss,NULL,"Enter Short");
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+